<?php

	global $wpdb;

	// Get core wizard data
	$ws_form_wizard = new WS_Form_Wizard;
	$wizard_categories = $ws_form_wizard->db_read_all_categories();

	// Add action categories
	$actions = $ws_form_wizard->db_get_actions();
	if($actions !== false) {

		foreach($actions as $action) {

			$action['action_id'] = $action['id'];
			$wizard_categories[] = $action;
		}
	}
?>
<script>

	// Localize
	var ws_form_settings_language_form_add_create = '<?php _e('Create', 'ws-form'); ?>';

</script>

<div class="wrap">

<!-- Header -->
<div class="wsf-heading">
<h1 class="wp-heading-inline"><?php _e('Add New', 'ws-form'); ?></h1>
<?php

	// Loader icon
	WS_Form_Common::loader();
?>
</div>
<hr class="wp-header-end">
<!-- /Header -->

<!-- Wizard -->
<div id="wsf-form-add">

<p><?php _e('Start a with a blank form or select a template. You can modify any template form with your own fields.', 'ws-form'); ?></p>

<!-- Tabs - Categories -->
<ul id="wsf-form-add-tabs">
<?php

	// Loop through wizards
	foreach ($wizard_categories as $wizard_category)  {

		$action_id = isset($wizard_category['action_id']) ? $wizard_category['action_id'] : false;

?><li><a href="#wsf_wizard_category_<?php echo $wizard_category['id']; ?>"><?php echo htmlentities($wizard_category['label']); ?><?php

		if(($action_id !== false) && ($wizard_category['reload'])) {

?><span data-action="wsf-api-reload" data-action-id="<?php echo htmlentities($action_id); ?>" data-method="lists_fetch" title="<?php _e('Update', 'ws-form'); ?>"><?php WS_Form_Common::render_icon_16_svg('reload'); ?></span><?php

		}

?></a></li>
<?php

	}
?>
</ul>
<!-- Tabs - Categories -->
<?php

	// Loop through wizards
	foreach ($wizard_categories as $wizard_category)  {
?>
<!-- Tab Content: <?php echo htmlentities($wizard_category['label']); ?> -->
<div id="wsf_wizard_category_<?php echo $wizard_category['id']; ?>"<?php if(isset($wizard_category['action_id'])) { ?> data-action-id="<?php echo $wizard_category['action_id']; ?>"<?php } ?>>

<ul class="wsf-templates">

<!-- Blank -->
<li>
<div class="wsf-template" data-action="wsf-add-blank" data-id="1">
<svg class="wsf-responsive" viewBox="0 0 140 180">
	<text font-family="-apple-system,BlinkMacSystemFont,"Segoe UI",Roboto,Oxygen-Sans,Ubuntu,Cantarell,"Helvetica Neue",sans-serif" font-size="12" fill="#000">
			<tspan x="5" y="16"><?php _e('Blank', 'ws-form'); ?></tspan>
	</text>
	<g fill="none" fill-rule="evenodd" transform="translate(5 7)">
		<path stroke="#CECED2" stroke-dasharray="4 2" d="M.5 17.5h129v149H.5z"/>
		<path fill="#002E5D" fill-rule="nonzero" d="M72 88.5h-5v-5h-2v5h-5v2h5v5h2v-5h5z"/>
	</g>
</svg>
</div>
<button class="wsf-button wsf-button-primary wsf-button-full" data-action="wsf-add-blank" data-id="1"><?php _e('Create', 'ws-form'); ?></button>
</li>
<!-- /Blank -->
<?php

		if(isset($wizard_category['wizards'])) {

			$wizards = $wizard_category['wizards'];

			// Loop through wizards
			foreach ($wizards as $wizard)  {

				// Is pro required to use this template?
				$pro_required = !WS_Form_Common::is_edition($wizard['pro_required'] ? 'pro' : 'basic');

?><li<?php if($pro_required) { ?> class="wsf-pro-required"<?php } ?>>
<div class="wsf-template" data-action="<?php if($pro_required) { ?>wsf-upgrade<?php } else { ?>wsf-add-wizard<?php } ?>" data-id="<?php echo $wizard['id']; ?>">
<?php
				if($pro_required) {
?><a href="<?php echo WS_Form_Common::get_plugin_website_url('', 'add_form'); ?>" target="_blank"><?php
				}

				// Parse SVG
				$svg = $wizard['svg'];
				$svg = str_replace('#label', htmlentities($wizard['label']), $svg);
				echo $svg;

				if($pro_required) {
?></a><?php
				}
?>
</div>
<?php
				if($pro_required) {
?>
<button class="wsf-button wsf-button-primary wsf-button-full" data-action="wsf-upgrade"><?php _e('PRO', 'ws-form'); ?></button>
<?php
				} else {
?>
<button class="wsf-button wsf-button-primary wsf-button-full" data-action="wsf-add-wizard" data-id="<?php echo $wizard['id']; ?>"><?php _e('Create', 'ws-form'); ?></button>
<?php
				}
?>
</li>
<?php
			}
		}
?>
</ul>

</div>
<!-- /Tab Content: <?php echo htmlentities($wizard_category['label']); ?> -->
<?php

	}
?>

</div>
<!-- /Wizard -->

<!-- Loading -->
<div id="wsf-form-add-loading"><p><?php _e("Your form is being built... just a moment.", 'ws-form'); ?></p></div>
<!-- /Loading -->

<!-- Form Actions -->
<form action="<?php echo WS_Form_Common::get_admin_url(); ?>" id="ws-form-action-do" method="post">
<input type="hidden" name="page" value="ws-form">
<input type="hidden" id="ws-form-action" name="action" value="">
<input type="hidden" id="ws-form-id" name="id" value="">
<input type="hidden" id="ws-form-action-id" name="action_id" value="">
<input type="hidden" id="ws-form-list-id" name="list_id" value="">
</form>
<!-- /Form Actions -->

<script>

	(function($) {

		'use strict';

		// On load
		$(function() {

			// Init wizard functionality
			var wsf_obj = new $.WS_Form();
			wsf_obj.wizard();
		});

	})(jQuery);

</script>

</div>
