<?php

	// Get ID of form (0 = New)
	$form_id = intval(WS_Form_Common::get_query_var('id', 0));
?>
<div class="wrap">

<!-- Header -->
<div class="wsf-heading">
<h1 class="wp-heading-inline"><?php _e('Edit Form', 'ws-form') ?></h1>

<!-- Form actions -->
<?php

	// Publish
	if(WS_Form_Common::can_user('publish_form')) {
?>
<button data-action="wsf-publish" class="wsf-button wsf-button-small wsf-button-information" disabled><?php WS_Form_Common::render_icon_16_svg('publish'); ?> <?php _e('Publish', 'ws-form'); ?></button>
<?php
	}
?>
<a class="wsf-button wsf-button-small" href="<?php echo get_site_url(null, '/?wsf_preview_form_id=' . $form_id); ?>" target="_blank"><?php WS_Form_Common::render_icon_16_svg('visible'); ?> <?php _e('Preview', 'ws-form'); ?></a>
<?php

	// Submissions
	if(WS_Form_Common::can_user('read_submission')) {
?>
<a class="wsf-button wsf-button-small" href="/wp-admin/admin.php?page=ws-form-submit&id=<?php echo $form_id; ?>"><?php WS_Form_Common::render_icon_16_svg('table'); ?> <?php _e('Submissions', 'ws-form'); ?></a>
<?php
	}

	// Loader icon
	WS_Form_Common::loader();
?>
<ul class="wsf-settings">
<li data-action="wsf-undo" title="<?php _e('Undo', 'ws-form'); ?>" class="wsf-undo-inactive"><?php WS_Form_Common::render_icon_16_svg('undo'); ?></li>
<li data-action="wsf-redo" title="<?php _e('Redo', 'ws-form'); ?>" class="wsf-redo-inactive"><?php WS_Form_Common::render_icon_16_svg('redo'); ?></li>
<?php

	// Upload
	if(WS_Form_Common::can_user('import_form')) {
?>
<li data-action="wsf-form-upload" title="<?php _e('Upload', 'ws-form'); ?>"><?php WS_Form_Common::render_icon_16_svg('upload'); ?></li>
<?php
	}

	// Download
	if(WS_Form_Common::can_user('export_form')) {
?>
<li data-action="wsf-form-download" title="<?php _e('Download', 'ws-form'); ?>"><?php WS_Form_Common::render_icon_16_svg('download'); ?></li>
<?php
	}
?>
</ul>
<?php

	// Upload
	if(WS_Form_Common::can_user('import_form')) {
?>
<input type="file" class="wsf-file-upload" id="wsf-form-upload-file" accept=".json"/>
<?php
	}
?>
</div>
<hr class="wp-header-end">
<!-- /Header -->

<!-- Wrapper -->
<div id="poststuff"><div id="post-body" class="metabox-holder columns-2"><div id="post-body-content" style="position: relative;">

<!-- Title -->
<div id="titlediv">
<div id="titlewrap">

<label class="screen-reader-text" id="title-prompt-text" for="title"><?php _e('Form Name'); ?></label>
<input type="text" id="title" class="wsf-field" data-action="wsf-form-label" name="form_label" size="30" value="" spellcheck="true" autocomplete="off" />

</div>
</div>
<!-- /Title -->

<!-- Left Column -->
<div id="postbox-container-2" class="postbox-container">

<!-- Form -->
<div id="wsf-form"></div>
<!-- /Form -->

<!-- Breakpoints -->
<div id="wsf-breakpoints"></div>
<!-- /Breakpoints -->

</div>
<!-- /Left Column -->

<!-- Sidebars -->
<div id="wsf-sidebars"></div>
<!-- /Sidebars -->

</div></div></div>
<!-- /Wrapper -->

<!-- Popover -->
<div id="wsf-popover" class="wsf-ui-cancel"></div>
<!-- /Popover -->

</div>
<!-- /Wrapper -->

<!-- WS Editor -->
<div id="wsf-text-editor-home" style="display: none;"><?php wp_editor('', 'wsf-text-editor'); ?></div>
<!-- /WS Editor -->

<script>

	var wsf_obj = null;

	(function($) {

		'use strict';

		// On load
		$(function() {

			// Initialize WS Form
			var wsf_obj = new $.WS_Form();
			wsf_obj.render({

				'obj' : 	'#wsf-form',
				'form_id':	<?php echo $form_id; ?>
			});
			wsf_obj.menu_highlight();
		});

	})(jQuery);

</script>
