<?php

	// Get options
	$options = WS_Form_Config::get_options();

	// Get current tab
	$tabCurrent = WS_Form_Common::get_query_var('tab', 'setup');

	// Check tab is valid
	if(!isset($options[$tabCurrent])) {
?>
<script>

	location.href = '<?php echo WS_Form_Common::get_admin_url('ws-form-settings'); ?>';

</script>
<?php

		exit;
	}

	// File upload checks
	$upload_checks = WS_Form_Common::uploads_check();
	$max_upload_size = $upload_checks['max_upload_size'];
	$max_uploads = $upload_checks['max_uploads'];
?>
<div id="wsf-settings" class="wrap">

<!-- Header -->
<div class="wsf-heading">
<h1 class="wp-heading-inline"><?php _e('Settings', 'ws-form'); ?></h1>
<?php

	// Loader icon
	WS_Form_Common::loader();
?>
</div>
<hr class="wp-header-end">
<!-- /Header -->

<h2 class="nav-tab-wrapper"> 
<?php

	// Render tabs
	foreach($options as $tab => $fields) {
?>
<a href="<?php echo admin_url('admin.php?page=ws-form-settings&tab=' . $tab); ?>" class="nav-tab<?php if($tabCurrent == $tab) { ?> nav-tab-active<?php } ?>"><?php echo $fields['label']; ?></a>
<?php

	}
?>
</h2>

<form method="post" action="admin.php?page=ws-form-settings<?php echo (WS_Form_Common::get_query_var('tab') != '') ? '&tab=' . urlencode(WS_Form_Common::get_query_var('tab')) : ''; ?>" novalidate="novalidate" id="wsf_settings">

<input type="hidden" name="tab" value="<?php echo $tabCurrent; ?>" />
<input type="hidden" name="action" value="wsf-settings-update" />
<input type="hidden" name="action_mode" id="wsf_action_mode" value="" />
<input type="hidden" name="action_license_action_id" id="wsf_action_license_action_id" value="" />
<input type="hidden" name="page" value="ws-form-settings" />
<?php

	$js_on_change = '';
	$save_button = false;

	if(isset($options[$tabCurrent]['fields'])) {

		$fields = $options[$tabCurrent]['fields'];
		$save_button = $save_button || render_fields($this, $fields, $max_uploads, $max_upload_size, $js_on_change);
	}

	if(isset($options[$tabCurrent]['groups'])) {

		$groups = $options[$tabCurrent]['groups'];

		foreach($groups as $group) {

			$heading = isset($group['heading']) ? $group['heading'] : false;
			$description = isset($group['description']) ? $group['description'] : false;
			$fields = $group['fields'];

			$save_button_return = render_fields($this, $fields, $max_uploads, $max_upload_size, $js_on_change, $heading, $description);
			$save_button = $save_button || $save_button_return;
		}
	}

	if($save_button) {
?>
<p class="submit"><input type="submit" name="wsf_submit" id="wsf_submit" class="button button-primary" value="Save Changes"></p>
<?php
	}
?>
</form>

<script>

	(function($) {

		'use strict';

		// On load
		$(function() {

			var wsf_obj = new $.WS_Form();

			var file_frame;

			// Set mode and submit
			$('[data-action="wsf-mode-submit"]').click(function() {

				$('#wsf_action_mode').val($(this).attr('data-mode'));
				$('#wsf_settings').submit();
			});

			// Framework detect
			$('[data-action="wsf-framework-detect"]').click(function() {

				var click_this = this;
				var for_id = '#' + $(this).attr('data-for');

				// Detect framework
				wsf_obj.framework_detect(function(framework) {

					// Set framework to that detected
					$(for_id).val(framework.type);

					// Switch loader off
					wsf_obj.loader_off();

				}, function() {

					// Set framework to default
					$(for_id).val('<?php echo WS_FORM_DEFAULT_FRAMEWORK; ?>');

					// Show info message
					wsf_obj.message('<?php _e('Your current theme does not contain a recognized framework. Using WS Form as the form framework.'); ?>', true, 'notice-info');

					// Switch loader off
					wsf_obj.loader_off();
				});
			});

			// Max upload size
			$('[data-action="wsf-max-upload-size"]').click(function() {

				var for_id = $(this).attr('data-for');
				$('#' + for_id).val(<?php echo $max_upload_size; ?>);
			});

			// Max uploads
			$('[data-action="wsf-max-uploads"]').click(function() {

				var for_id = $(this).attr('data-for');
				$('#' + for_id).val(<?php echo $max_uploads; ?>);
			});

			// Image selector
			$('[data-action="wsf-image"]').click(function(e) {

				var for_id = $(this).attr('data-for');

				// If the media frame already exists, reopen it.
				if(file_frame) {

					// Open frame
					file_frame.open();
					return;
				}

				// Create the media frame.
				file_frame = wp.media.frames.file_frame = wp.media({

					title: 'Select a image to upload',
					button: {
						text: 'Use this image',
					},
					multiple: false
				});

				// When an image is selected, run a callback.
				file_frame.on('select', function() {

					// We set multiple to false so only get one image from the uploader
					var attachment = file_frame.state().get('selection').first().toJSON();

					// Sets the image ID
					var image_id = attachment.id;
					var image_id_obj = $('#' + for_id);
					image_id_obj.val(image_id);

					// Get thumbnail size
					if(typeof(attachment.sizes.<?php echo WS_FORM_SETTINGS_IMAGE_PREVIEW_SIZE; ?>) !== 'undefined') {
						var image_size = attachment.sizes.<?php echo WS_FORM_SETTINGS_IMAGE_PREVIEW_SIZE; ?>;
					} else {
						var image_size = attachment.sizes.thumbnail;	
					}
					var image_width = image_size.width;
					var image_height = image_size.height;
					var image_url = image_size.url;

					// Set the preview
					var image_obj = $('#' + for_id + '_preview_image');
					if(image_obj.length == 0) {

						$('<div id="' + for_id + '_preview" class="wsf-settings-image-preview"><img id="' + for_id + '_preview_image" src="' + image_url + '" width="' + image_width + '" height="' + image_height + '" class="attachment-<?php echo WS_FORM_SETTINGS_IMAGE_PREVIEW_SIZE; ?> size-<?php echo WS_FORM_SETTINGS_IMAGE_PREVIEW_SIZE; ?>" /><div data-action="wsf-image-reset" data-for="' + for_id + '"><?php WS_Form_Common::render_icon_16_svg('minus-circle'); ?></div></div>').insertAfter(image_id_obj);

							// Image selector reset
							$('[data-action="wsf-image-reset"]').click(function(e) {

								var for_id = $(this).attr('data-for');
								var image_id_obj = $('#' + for_id);
								image_id_obj.val('');
								$('#' + for_id + '_preview').remove();
							});

					} else {

						image_obj.attr('src', image_url);
						image_obj.removeAttr('srcset');
						image_obj.attr('width', image_width);
						image_obj.attr('height', image_height);
					}
				});

				// Finally, open the modal
				file_frame.open();
			});

			// Image selector reset
			$('[data-action="wsf-image-reset"]').on('click', function(e) {

				var for_id = $(this).attr('data-for');
				var image_id_obj = $('#' + for_id);
				image_id_obj.val('');
				$('#' + for_id + '_preview').remove();
			});
<?php

	if($js_on_change != '') { echo $js_on_change; }
?>
		});

	})(jQuery);

</script>

</div>
<?php

	function render_fields($wsform, $fields, $max_uploads, $max_upload_size, &$js_on_change, $heading = false, $description = false) {

		global $image_preview_size;

		// Heading
		if($heading !== false) {
?>
<h2 class="title"><?php echo $heading; ?></h2>
<?php
		}

		// Description
		if($description !== false) {
?>
<p><?php echo $description; ?></p>
<?php
		}
?>
<table class="form-table"><tbody>
<?php
		$save_button = false;

		foreach($fields as $field => $attributes) {

			// Hidden values
			if($attributes['type'] == 'hidden') { continue; }

			// Condition
			if(isset($attributes['condition'])) {

				$condition_result = true;
				foreach($attributes['condition'] as $condition_field => $condition_value) {

					$condition_value_check = WS_Form_Common::option_get($condition_field);
					if($condition_value_check != $condition_value) {

						$condition_result = false;
						break;
					}
				}
				if(!$condition_result) { continue; }
			}

			// Minimum
			$minimum = (isset($attributes['minimum'])) ? absint($attributes['minimum']) : false;

			// Maximum
			if(isset($attributes['maximum'])) {

				$maximum = $attributes['maximum'];

				switch($maximum) {

					case '#max_upload_size' : $maximum = $max_upload_size; break;
					case '#max_uploads' : $maximum = $max_uploads; break;
				}

			} else {

				$maximum = false;
			}
?>
<tr>
<?php
			if($attributes['label'] !== false) {
?>
<th scope="row"><label for="wsf_<?php echo $field; ?>"><?php _e($attributes['label']); ?></label></th>
<?php
			}
?>
<td<?php if($attributes['label'] === false) { ?> colspan="2"<?php } ?>><?php

			$default = isset($attributes['default']) ? $attributes['default'] : false;
			$value = esc_html(WS_Form_Common::option_get($field, $default, true));

			switch($attributes['type']) {

				// Static value
				case 'static' :

					switch($field) {

						// Version
						case 'version' : echo WS_FORM_VERSION; break;


						// System
						case 'system' :

							echo WS_Form_Common::get_system_report_html();
							break;

						default :

							// Other
							$value = apply_filters('wsf_settings_static', $value, $field);
							echo $value;
					}
					break;

				// File Get Content
				case 'file_get_contents' :

					if(isset($attributes['url'])) {

						// Build action product ID's
						$action_license_item_id_array = array();
						foreach(WS_Form_Action::$actions as $action) {

							if(method_exists($action, 'get_license_item_id')) {

								$action_license_item_id_array[] = $action->get_license_item_id();
							}
						}
						$action_license_item_ids = implode(',', $action_license_item_id_array);

						$url_variables = array(

							'locale' 					=> rawurlencode(get_locale()),
							'version'					=> rawurlencode(WS_FORM_VERSION),
							'action_license_item_ids'	=> rawurlencode($action_license_item_ids)
						);

						$url = WS_Form_Common::mask_parse($attributes['url'], $url_variables);

						echo '<div id="wsf-settings-content">';

						$response = @file_get_contents($url);
						if($response !== false) {

							echo $response;

						} else {

							echo sprintf(__('<a href="%s" target="_blank">Click here</a> to learn more about WS Form PRO.', 'ws-form'), WS_Form_Common::get_plugin_website_url('', 'settings'));
						}

						echo '</div>';
					}
					break;

				// Text field
				case 'text' :
?>
<input class="regular-text" name="<?php echo $field; ?>" type="text" id="wsf_<?php echo $field; ?>" value="<?php echo $value; ?>" />
<?php
					$save_button = true;
					break;

				// Password field
				case 'password' :
?>
<input class="regular-text" name="<?php echo $field; ?>" type="password" id="wsf_<?php echo $field; ?>" value="<?php echo $value; ?>" />
<?php
					$save_button = true;
					break;

				// Key field
				case 'key' :
?>
<input class="regular-text" name="<?php echo $field; ?>" type="text" id="wsf_<?php echo $field; ?>" value="<?php echo $value; ?>" />
<?php
					$save_button = true;
					break;

				// Number field
				case 'number' :
?>
<input class="regular-text" name="<?php echo $field; ?>" type="number" id="wsf_<?php echo $field; ?>" value="<?php echo $value; ?>"<?php

					if($minimum !== false) { echo ' min="' . $minimum . '"'; }
					if($maximum !== false) { echo ' max="' . $maximum . '"'; }
?> /><?php
					$save_button = true;
					break;

				// Color field
				case 'color' :
?>
<input name="<?php echo $field; ?>" type="color" id="wsf_<?php echo $field; ?>" value="<?php echo $value; ?>" />
<?php
					$save_button = true;
					break;

				// Checkbox field
				case 'checkbox' :

					$value = ($value == 1);
?>
<input name="<?php echo $field; ?>" type="checkbox" id="wsf_<?php echo $field; ?>" value="1"<?php if($value) { ?> checked="checked"<?php } ?> />
<?php
					$save_button = true;
					break;

				// Selectbox field
				case 'select' :
?>
<select name="<?php echo $field; ?>" id="wsf_<?php echo $field; ?>">
<?php
					// Render options
					$options = $attributes['options'];
					foreach($options as $option_value => $option_array) {

						$option_text = $option_array['text'];

?><option value="<?php echo $option_value; ?>"<?php if($option_value == $value) { ?> selected<?php } ?>><?php echo $option_text; ?></option>
<?php
					}
?>
</select>
<?php
					$save_button = true;
					break;

				// Selectbox field (Number)
				case 'select_number' :
?>
<select name="<?php echo $field; ?>" id="wsf_<?php echo $field; ?>">
<?php
					// Render options
					$minimum = isset($attributes['minimum']) ? $attributes['minimum'] : 1;
					$maximum = isset($attributes['maximum']) ? $attributes['maximum'] : 100;
					for($option_value = $minimum; $option_value <= $maximum; $option_value++) {

?><option value="<?php echo $option_value; ?>"<?php if($option_value == $value) { ?> selected<?php } ?>><?php echo $option_value; ?></option>
<?php
					}
?>
</select>
<?php
					$save_button = true;
					break;

				// Image
				case 'image' :
?>
<input name="<?php echo $field; ?>" type="hidden" id="wsf_<?php echo $field; ?>" value="<?php echo $value; ?>" />
<?php
					// Get the image ID
					$image_id = absint($value);
					if($image_id == 0) { break; }

					// Show preview image
					$image = wp_get_attachment_image($image_id, WS_FORM_SETTINGS_IMAGE_PREVIEW_SIZE, false, array('id' => 'wsf_' . $field . '_preview_image'));
					if($image) {
?>
<div id="wsf_<?php echo $field; ?>_preview" class="wsf-settings-image-preview"><?php echo $image; ?><div data-action="wsf-image-reset" data-for="wsf_<?php echo $field; ?>"><?php WS_Form_Common::render_icon_16_svg('minus-circle'); ?></div></div>
<?php
					}

					$save_button = true;
					break;

				// Image size
				case 'image_size' :
?>
<select name="<?php echo $field; ?>" id="wsf_<?php echo $field; ?>">
<?php
					// Render image sizes
					$image_sizes = get_intermediate_image_sizes();
					$image_sizes[] = 'full';
					foreach($image_sizes as $image_size) {

?><option value="<?php echo $image_size; ?>"<?php if($image_size == $value) { ?> selected<?php } ?>><?php echo $image_size; ?></option>
<?php
					}
?>
</select>
<?php
					$save_button = true;
					break;
			}

			// Buttons
			if(isset($attributes['button'])) {

				$button = $attributes['button'];

				switch($button) {

					case 'wsf-license' :

						$license_activated = WS_Form_Common::option_get('license_activated', false);
						if($license_activated) {
?>
<input class="button" type="button" data-action="wsf-mode-submit" data-mode="deactivate" value="<?php _e('Deactivate', 'ws-form'); ?>" />
<?php
						} else {
?>
<input class="button" type="button" data-action="wsf-mode-submit" data-mode="activate" value="<?php _e('Activate', 'ws-form'); ?>" />
<?php
						}

						break;

					case 'wsf-framework-detect' :
?>
<input class="button" type="button" data-action="wsf-framework-detect" data-for="wsf_<?php echo $field; ?>" value="<?php _e('Detect', 'ws-form'); ?>" />
<?php
						break;

					case 'wsf-key-generate' :
?>
<input type="button" class="button" data-action="wsf-key-generate" data-for="wsf_<?php echo $field; ?>" value="<?php _e('Generate', 'ws-form'); ?>" />
<?php
						break;

					case 'wsf-max-upload-size' :
?>
<input type="button" class="button" data-action="wsf-max-upload-size" data-for="wsf_<?php echo $field; ?>" value="<?php _e('Use php.ini value', 'ws-form'); ?>" />
<?php
						break;

					case 'wsf-max-uploads' :
?>
<input type="button" class="button" data-action="wsf-max-uploads" data-for="wsf_<?php echo $field; ?>" value="<?php _e('Use php.ini value', 'ws-form'); ?>" />
<?php
						break;

					case 'wsf-image' :

?>
<input type="button" class="button" data-action="wsf-image" data-for="wsf_<?php echo $field; ?>" value="<?php _e('Select image...', 'ws-form'); ?>" />
<?php
						break;

					default :

						// Other
						$value = apply_filters('wsf_settings_button', '', $field, $button);
						echo $value;
				}
			}

			if(isset($attributes['help'])) {

				$help = $attributes['help'];
				echo '<p class="description" id="' . $field . '_description">' . $help . '</p>';
			}

			if(isset($attributes['reload_on_change']) && $attributes['reload_on_change']) {

				$js_on_change .= "\n			$('#wsf_$field').change(function() { $('#wsf_settings').submit(); });";
			}
?></td>
</tr>
<?php
		}
?>
</tbody></table>
<?php

		return $save_button;
	}
