<!-- Welcome Banner -->
<div id="wsf-welcome">
<?php

	WS_Form_Common::loader();
?>
<!-- Slide 1 - Welcome -->
<div class="wsf-welcome-slide" data-id="1">

<div class="wsf-welcome-copy">
<div class="wsf-welcome-title"><?php _e(sprintf('This is %s', WS_FORM_NAME_PRESENTABLE), 'ws-form'); ?></div>
<div class="wsf-welcome-intro"><?php _e('The Ultimate WordPress Form Builder', 'ws-form'); ?></div>
</div>

<button class="wsf-welcome-button" data-slide-next-id="2"><?php _e('Click to Start', 'ws-form'); ?></button>

</div>
<!-- /Slide 1 - Welcome -->

<!-- Slide 2 - Basic / Advanced -->
<div class="wsf-welcome-slide" data-id="2">

<div class="wsf-welcome-copy">
<div class="wsf-welcome-title"><?php _e('How familiar are you with creating forms?', 'ws-form') ?></div>
<div class="wsf-welcome-intro"><?php _e('If you\'re new to creating forms, we\'ll keep it simple.', 'ws-form'); ?></div>
</div>

<button class="wsf-welcome-button" data-slide-next-id="5" data-action="wsf-mode-set" data-value="basic"><?php _e('Keep it simple', 'ws-form') ?></button>
<button class="wsf-welcome-button" data-slide-next-id="5" data-action="wsf-mode-set" data-value="basic"><?php _e('I\'m familiar', 'ws-form') ?></button>
<button class="wsf-welcome-button" data-slide-next-id="4" data-action="wsf-mode-set" data-value="advanced"><?php _e('I\'m a developer', 'ws-form') ?></button>

</div>
<!-- /Slide 2 - Basic / Advanced -->

<!-- Slide 3 - Framework Detect -->
<div class="wsf-welcome-slide" data-id="3">

<div class="wsf-welcome-copy">
<div class="wsf-welcome-title"><?php _e("You're using <span id=\"wsf-welcome-framework\"></span>", 'ws-form') ?></div>
<div class="wsf-welcome-intro"><?php _e('Is that correct?', 'ws-form'); ?></div>
</div>

<button class="wsf-welcome-button" data-slide-next-id="5" data-action="wsf-framework-set"><?php _e('Yes'); ?></button>
<button class="wsf-welcome-button" data-slide-next-id="4"><?php _e('No', 'ws-form'); ?></button>
<button class="wsf-welcome-button" data-slide-next-id="5"><?php _e('Not sure', 'ws-form'); ?></button>

</div>
<!-- /Slide 3 - Framework Detect -->

<!-- Slide 4 - Framework Select-->
<div class="wsf-welcome-slide" data-id="4">

<div class="wsf-welcome-copy">
<div class="wsf-welcome-title"><?php _e('Are you using a framework?', 'ws-form') ?></div>
<div class="wsf-welcome-intro"><?php _e('Select a framework from the list below. You can change this later.', 'ws-form'); ?></div>
</div>

<select id="framework" data-slide-next-id="5">
<option value=""><?php _e("Select..."); ?></option>
<option value="<?php echo WS_FORM_DEFAULT_FRAMEWORK; ?>"><?php _e('I\'m not using a framework', 'ws-form'); ?></option>
<option value="<?php echo WS_FORM_DEFAULT_FRAMEWORK; ?>"><?php _e('I\'m not sure', 'ws-form'); ?></option>
<?php

	$frameworks = WS_Form_Config::get_frameworks(false);
	$framework_types = $frameworks['types'];
	foreach($framework_types as $type => $framework) {

		// Skip default framework (ws-form)
		if($type == WS_FORM_DEFAULT_FRAMEWORK) { continue; }

?><option value="<?php echo $type; ?>"><?php echo $framework['name']; ?></option>
<?php

	}

?></select>

</div>
<!-- /Slide 4 - Framework Select -->

<!-- Slide 5 - Setup Complete -->
<div class="wsf-welcome-slide" data-id="5" data-action="wsf-setup-push">

<div class="wsf-welcome-copy">
<div class="wsf-welcome-title"><?php _e('All Done!', 'ws-form') ?></div>
<div class="wsf-welcome-intro"><?php _e('You\'re ready to create your first form', 'ws-form'); ?></div>
</div>

<div class="wsf-container">
<div class="wsf-video-container">
<iframe id="wsf-video-welcome" src="https://player.vimeo.com/video/289590605?api=1" width="640" height="360" frameborder="0" webkitallowfullscreen mozallowfullscreen allowfullscreen allow="autoplay; encrypted-media"></iframe>
</div>
</div>

<script src="https://player.vimeo.com/api/player.js"></script>

<div><button class="wsf-welcome-button" data-action="wsf-form-add"><?php _e('Get Started...', 'ws-form'); ?></button></div>

</div>
<!-- /Slide 5 - Setup Complete -->

</div>
<!-- /Welcome Banner -->

<script>

	// Options
	var params_setup = {

		'framework': '<?php echo WS_FORM_DEFAULT_FRAMEWORK; ?>',
		'mode': '<?php echo WS_FORM_DEFAULT_MODE; ?>'
	};

	var framework_detected = false;

	(function($) {

		'use strict';

		var wsf_obj = new $.WS_Form();
		var wsf_welcome_banner = $('#wsf-welcome');

		// Slide buttons
		$('.wsf-welcome-button', wsf_welcome_banner).click(function() {

			user_action($(this), $(this).attr('data-value'));
		});

		// Slide select
		$('select', wsf_welcome_banner).change(function() {

			user_action($(this), $(this).val());
		});

		function user_action(obj, value) {

			var slide_next_id = obj.attr('data-slide-next-id');

			// Button actions
			var action_button = obj.attr('data-action');
			switch(action_button) {

				// Set framework type
				case 'wsf-framework-set' :

					if(framework_detected !== false) {

						params_setup['framework'] = framework_detected.type;
					}
					break;

				// Set mode
				case 'wsf-mode-set' :

					params_setup['mode'] = value;
					break;

				// Add form
				case 'wsf-form-add' :

					location.href='<?php echo WS_Form_Common::get_admin_url('ws-form-add'); ?>';
					break;
			}

			var slide_current = obj.closest('.wsf-welcome-slide');

			slide_current.fadeOut(200, function() {

				// Get next slide object
				var slide_next = $('.wsf-welcome-slide[data-id="' + slide_next_id + '"]');

				// Start video
				if(slide_next_id == '5') {

					setTimeout(function() {

						var iframe = $('#wsf-video-welcome');
						var player = new Vimeo.Player(iframe[0]);
						player.play();

					}, 200);
				}

				// Process action
				var action_slide = slide_next.attr('data-action');
				switch(action_slide) {

					case 'wsf-setup-push' :

						wsf_obj.setup_push(params_setup, function() {

							// Success
							slide_next.fadeIn(200);

							// Turn off loader
							wsf_obj.loader_off();

						}, function() {

							// Error
							slide_current.fadeIn(200);

							// Turn off loader
							wsf_obj.loader_off();
						});

						break;

					default :

						slide_next.fadeIn(200);
				}
			});
		}

		// On load
		$(function() {

			// Detect framework
			wsf_obj.framework_detect(function(framework) {

				// Remember framework detected
				framework_detected = framework;

				// Set framework name
				$('#wsf-welcome-framework').html(framework.name);

				// Reconfigure path
				$('.wsf-welcome-slide[data-id="2"] .wsf-welcome-button[data-value="advanced"]').attr('data-slide-next-id', '3');

				// Turn off loader
				wsf_obj.loader_off();

			}, function() {

				// Turn off loader
				wsf_obj.loader_off();
			});
		});

	})(jQuery);

</script>

